#include "ace/OS.h"
#include "ace/Task.h"

class TaskOne: public ACE_Task<ACE_MT_SYNCH>{
public:
//Implement the Service Initialization and Termination methods

  int open(void *){
    ACE_DEBUG((LM_DEBUG,"(%t) Active Object opened \n"));
    
    //Activate an object with a thread in it.
    activate();
    return 0;
  }

  int close(u_long){
    ACE_DEBUG((LM_DEBUG,"(%t) Active Object being closed down \n"));

    return 0;
  }

  int svc(void){
    ACE_DEBUG((LM_DEBUG,"(%t) This is being done in separate thread \n"));

    //Do thread specific work here
    ACE_OS::sleep(1);
    return 0;

  }
};

int main(int argc, char *argv[]){
	//Create the task
	
	TaskOne *one = new TaskOne;

	//Start uo the task
	one->open(0);


	//Wait for all the task to exit
	ACE_Thread_Manager::instance()->wait();
	ACE_DEBUG((LM_DEBUG,"(%t) Main Task ends \n"));
}
	
        
